/* scanner for a SDL language */
%{
#include "comptypes.h"
#include "gramm.h"
%}

DIGIT [0-9]
ALPHA [a-z]
ID [a-z][a-z0-9]*
SPACES [ \n\t\r]

%%
{SPACES}+	/*ignory spaces*/	

	/* keywords */
circuit 	{return CIRCUIT;}
inputs  	{return INPUTS;}
outputs 	{return OUTPUTS;}
transist	{return TRANSIST;}
endtrans	{return ENDTRANSIST;}
gates   	{return GATES;}
endgates	{return ENDGATES;}
end     	{return END;}

\'[pnd]\'	{yylval.sym=yytext[1];return TRANSISTTYPE;} 
\"[pnd]\"	{yylval.sym=yytext[1];return TRANSISTTYPE;} 

{ID}     	{yylval.string=yytext;return IDENT;}
{DIGIT}+	{yylval.num=atoi(yytext); return NUMBER;} 
#{DIGIT}+	{yylval.num=atoi(&(yytext[1])); return POSITION;} 

\'       	{return Q1;}
\"       	{return Q2;}

";"        	{return ';';}
","      	{return ',';}
"-"      	{return '-';}
"("      	{return '(';}
")"      	{return ')';}

%%

